#!/usr/bin/perl

###############################################################################
#                                                                             #
#               Umfrage/ID V1.0 - Statistik                                   #
#               Alle Rechte vorbehalten                                       #
#               Copyright (C) 2007 Dipl.-Ing. Markus Robert Kessler           #
#               Bad Schussenried, Germany                                     #
#                                                                             #
#               Aktualisierungen unter http://developer.dipl-ing-kessler.de   #
#                                                                             #
###############################################################################
#                                                                             #
#               Einsatz:                                                      #
#                                                                             #
#               Abstimm- und Auswerteprogramm fuer Statistikzwecke            #
#               unter Verwendung von Identifikationsreferenzen, IDs           #
#                                                                             #
#               Folgende Faelle:                                              #
#                                                                             #
#               Fall_1: Aufruf ohne ID                                        #
#                       - Errechnen und Anzeige statistische Auswertung       #
#               Fall_2: Aufruf mit ungueltiger oder bereits verwendeter ID    #
#                       - Errechnen und Anzeige statistische Auswertung       #
#               Fall_3: Aufruf mit gueltiger ID, keine Abstimmauswahl         #
#                       - Anzeige der Abtimmflaechen, Stimmabgabe gefordert   #
#               Fall_4: Aufruf mit gueltiger ID und Abstimmauswahl            #
#                       - Verifikation Gueltigkeit ID                         #
#                       - Entfernen ID aus erg-Datei                          #
#                       - Uebernahme Auswahl in erg-Datei                     #
#                                                                             #
###############################################################################

$titel          = 'Umfrage: Leistungskurs Latein im Zitateverteiler?';
$ueberschrift   = "<hr>\n<table width=100\%>\n<tr>\n<td bgcolor=\"\#AACCAA\" align=
                  center><font face=\"Arial, Helvetica\" size=5 color=Purple>
                  <b>Umfrage: Wird ein weiterer Leistungskurs Latein gewnscht?</b></td>\n</tr>\n</table><hr>";
@auswahl_name   = ("Ja, gerne!" , "Keine Meinung..." , "Ich brauch\' kein Latein!");
@balkendatei    = ("gruen.gif"     , "gelb.gif"     , "rot.gif" );
$datei_ort      = "/images";                 # Relativ zu Apache Document Root #
$vertikal       = 'ja';          # Abstimm-Auswahl unter- oder nebeneinander ? #

$id_datei       = "umfraid2.id";
$erg_datei      = "umfraid2.erg";
$br_force_verzg = "2";
$abst_ja_nein   = "ja";
$backgnd        = "/backgnd/boback8a.jpg";

$format0    = "</font><font face=\"Arial, Helvetica\" size=5 color=Red><b>";
$format1    = "</font><font face=\"Arial, Helvetica\" size=3 color=Purple><b>";
$format2    = "</font><font face=\"Arial, Helvetica\" size=5 color=Maroon><b>";
$format3    = "</font><font face=\"Arial, Helvetica\" size=5 color=Red><b>";
$format4    = "</font><font face=\"Arial, Helvetica\" size=6 color=White><b>";
$format5    = "</font><font face=\"Arial, Helvetica\" size=4 color=Red><b>";

### Bitte ab hier nichts mehr aendern #########################################

$faktor        = '0.5';           # An Breite der Balken-Gif-Dateien anpassen #

$copyright='<hr><table width="100%"><tr><td align=right><font face="helvetica,arial" size="2" color="Gray">
Programmierung und Design: <a target="_new" href="http://www.dipl-ing-kessler.de">
www.dipl-ing-kessler.de</a></font></td></tr></table>';

# Uebergabeparameter auslesen
$buffer=$ENV{'QUERY_STRING'};
@pairs = split(/&/, $buffer);

foreach $pair (@pairs) {
    ($name, $value) = split(/=/, $pair);

    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/<!--(.|\n)*-->//g;

    if ( $name eq 'ID' ) {
        $ID = $value;
    }

    if ( $name eq 'Auswahl' ) {
        $Auswahl = $value;
    }
}


### Direkter Aufruf ueber URL ###
if ( $ID eq '' && $Auswahl eq '' ) {
    Anzeige_Statistik ();
}

### Wiederholter Aufruf ueber Verweis in Nachricht ###
elsif ( $ID ne '' && ( ID_gueltig ( $ID ) eq '0' ) && $Auswahl eq '' ) {
    Anzeige_Statistik ();
}

### Erster Abstimmversuch mit gueltiger ID ###
elsif ( $ID ne '' && ( ID_gueltig ( $ID ) eq '1' ) && $Auswahl eq '' ) {
    Zeige_Auswahl ();
}

### Abstimmung mit gueltiger ID und nichtleerer Auswahl ###
elsif ( $ID ne '' && ( ID_gueltig ( $ID ) eq '1' ) && $Auswahl ne '' ) {
    Verarbeite_Auswahl ();
    Anzeige_Statistik ();
}

### Versuchte Abstimmung mit ungueltiger ID und nichtleerer Auswahl ###
### Hacker-Angriff? - Verzoegere Verarbeitung und zeige Statistik   ###

else {
    sleep ( $br_force_verzg );
    Anzeige_Statistik ();
}



sub Anzeige_Statistik {

    open ( ErgebnisDatei , "$erg_datei");
    flock ( ErgebnisDatei , 1 );
    for ( $i = 0 ; $i < @auswahl_name ; $i++ ) {
        $auswahl_anzahl[$i] = <ErgebnisDatei>;    # @auswahl_anzahl: Stimme fr jeweilige Auswahl #
        chomp ( $auswahl_anzahl[$i] );
    }
    close(ErgebnisDatei);

    $summe = '0';
    for ( $i = 0 ; $i < @auswahl_name ; $i++ ) {
        $summe += $auswahl_anzahl[$i];
    }

    for ( $i = 0 ; $i < @auswahl_name ; $i++ ) {
        if ( $summe > '0' ) {
            $auswahl_anzahl_prozent[$i] = int ( 0.5 + (10000*$auswahl_anzahl[$i]/$summe)) / 100;
            $balkenlaenge[$i]           = int (0.5 + ( $auswahl_anzahl_prozent[$i] * $faktor));
        }
        else {
            $auswahl_anzahl_prozent[$i] = '0';
            $balkenlaenge[$i]           = '0';
        }
    }

    print "Content-Type: text/html\n\n";
    print "<html>\n<head>\n<title>$titel - Auswertung</title>\n</head>\n";
    print "<body background=$backgnd text=\"Gray\" link=\"Gray\" alink=\"Gray\" vlink=\"Gray\">\n";
    print "<center>\n";

    print "$ueberschrift\n";

    print "<br>$format5";
    print "Auswertung der Abstimm-Ergebnisse:<p>\n";

    print "<table border=5><tr><td>\n";
    print "<table border=0>\n";
    print "<tr><td height=5> </td></tr>\n";
    print "<tr><td> </td><td>$format1 Auswertung prozentual:</td></tr>\n";

    for ($i=0; $i < @auswahl_name; $i++) {
        print "<tr><td>$format1 $auswahl_name[$i]</td>\n";
        print "<td>\n";
        print "<img src=$datei_ort/null.gif>";
        for ($zaehler=0 ; $zaehler<$balkenlaenge[$i] ; $zaehler++) {
            print "<img src=$datei_ort/$balkendatei[$i]>";
        }
        $ausgabe = sprintf ("%.02f", $auswahl_anzahl_prozent[$i]);
        print "$format1 $ausgabe \%";
        print "</td></tr>\n";
    }

    print "<tr><td height=10> </td></tr>\n";

    print "<tr><td> </td><td>$format1 Auswertung absolut:</td></tr>\n";

    for ($i=0; $i < @auswahl_name; $i++) {
        print "<tr><td>$format1 $auswahl_name[$i]</td>\n";
        print "<td><img src=$datei_ort/null.gif>$format1 $auswahl_anzahl[$i]</td></tr>\n";
    }

    print "<tr><td>$format1 Summe:</td>\n";
    print "<td><img src=$datei_ort/null.gif>$format1 $summe</td></tr>\n";

    print "<tr><td height=10> </td></tr>\n";

    print "</table>\n";
    print "</td></tr></table>\n";
    print "<br><br></center>\n<br>\n$copyright\n";
    print "</body>\n</html>\n";
}


sub Zeige_Auswahl {

    my $i;

    print "Content-Type: text/html\n\n";
    print "<html>\n<head>\n<title>$titel - Abstimmung</title>\n</head>\n";
    print "<body background=$backgnd text=\"Gray\" link=\"Gray\" alink=\"Gray\" vlink=\"Gray\">\n";
    print "<center>\n";

    print "$ueberschrift\n";

    print "<br>$format5";
    print "Bitte abstimmen - jede Stimme z&auml\;hlt!<p>\n";

    print "<br>$format1";

    print "<form method=GET action=\"$ENV{'SCRIPT_NAME'}\">\n";
    for ( $i=0 ; $i < @auswahl_name ; $i++ ) {
        print "<input type=\"radio\" name=\"Auswahl\"";
        if($i eq '0') {
            print " checked";
        }
        print " value=\"$i\">$auswahl_name[$i]\n";
        if($vertikal eq 'ja') {
            print "<p>";
        }
    }
    print "<p>";
    print "<input type=\"hidden\" name=\"ID\" value=\"$ID\">\n";
    print "<input type=\"submit\" value=\"   Abstimmen   \">\n";
    print "</form>\n";
    print "<br><br></center>\n<br>\n$copyright\n";
    print "</body>\n</html>\n";
}


sub Verarbeite_Auswahl {

    my $i;

    if ( ID_gueltig ( $ID ) eq '0' ) {  # Inzwischen mit gleicher ID abgestimmt
        Anzeige_Statistik ();
    }
    elsif ( $abst_ja_nein eq 'ja' ) {
        Entferne_ID ( $ID );
        Speichere_Auswahl ( $Auswahl );
    }
}


sub ID_gueltig {
    my $ID = @_[0];

    my $i;
    my $enthalten = '0';
    open ( ID_Datei , "$id_datei" ) or die "I/O error: $!\n";
    flock ( ID_Datei , 1 );
    my @lines = <ID_Datei>;
    close ( ID_Datei );
    foreach $i ( @lines ) {
        chomp ( $i );
        if ( $ID eq $i ) {
            $enthalten = '1';
        }
    }
    return ( $enthalten );
}


sub Entferne_ID {
    my $ID = @_[0];
    my $i;

    open ( ID_Datei , "+<$id_datei" ) or die "I/O error: $!\n";
    flock ( ID_Datei , 2 );
    my @IDs = <ID_Datei>;

    seek ( ID_Datei , 0 , 0 );
    truncate ( ID_Datei , 0 );

    foreach $i ( @IDs ) {
        chomp ( $i );
        if ( $i ne $ID ) {
            print ID_Datei "$i\n";
        }
    }
    close( ID_DATEI );
}


sub Speichere_Auswahl {
    my $Auswahl = @_[0];
    my $i;

    open ( ErgebnisDatei , "+<$erg_datei");
    flock ( ErgebnisDatei , 2 );
    for ( $i = 0 ; $i < @auswahl_name ; $i++ ) {
        $auswahl_anzahl[$i] = <ErgebnisDatei>;    # @auswahl_anzahl: Stimme fr jeweilige Auswahl #
        chomp ( $auswahl_anzahl[$i] );
    }

    seek ( ErgebnisDatei , 0 , 0 );
    truncate ( ErgebnisDatei , 0 );

    for ( $i = 0 ; $i < @auswahl_name ; $i++ ) {
        if ( $i eq $Auswahl ) {
            $auswahl_anzahl [ $i ] ++;
        }
        print ErgebnisDatei "$auswahl_anzahl[$i]\n";
    }
    close(ErgebnisDatei);
}

exit;
